// Direct3DRM.cpp: CDirect3DRM NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Direct3DRM.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CDirect3DRM::CDirect3DRM()
{
	m_bInit = false;

	m_pDirect3DRM = NULL;
	m_pDirect3DRMDevice = NULL;
	m_pDirect3DRMViewport = NULL;
}

CDirect3DRM::~CDirect3DRM()
{
	ReleaseAll();
}

void CDirect3DRM::ReleaseAll()
{
	if(	m_pDirect3DRMViewport != NULL )
	{
		m_pDirect3DRMViewport->Release();
		m_pDirect3DRMViewport = NULL;
	}
	if(	m_pDirect3DRMDevice != NULL )
	{
		m_pDirect3DRMDevice->Release();
		m_pDirect3DRMDevice = NULL;
	}
	if(	m_pDirect3DRM != NULL )
	{
		m_pDirect3DRM->Release();
		m_pDirect3DRM = NULL;
	}

	m_bInit = false;
}

bool CDirect3DRM::Initialize( CDirectDraw* pDD , CDirectDrawSurface* pBack , CDirect3DIM* pIM )
{
	if( !pDD->m_bInit )
		return false;

	ReleaseAll();

	HRESULT hr;
	// Direct3DRMIuWFNg
	IDirect3DRM* lpD3DRM;
	hr = Direct3DRMCreate(&lpD3DRM);
	// VDirect3DRMIuWFNgւ̃C^[tF[X擾
	hr = lpD3DRM->QueryInterface(IID_IDirect3DRM3,(void **)&m_pDirect3DRM);
	lpD3DRM->Release();
	if( hr!=D3DRM_OK )
		return false;

	// ZBufferp̃f[^
	DWORD dwZBufferMemType = DDSCAPS_SYSTEMMEMORY;
	DWORD dwZBufferBitDepth = 16;
	if( pIM!=NULL )
	{
		if( pIM->m_DevInfo.bHard )
		{
			dwZBufferMemType = DDSCAPS_VIDEOMEMORY;
			dwZBufferBitDepth = pIM->m_DevInfo.ZDepth;
		}
	}

	// Zobt@̍킩Ȃ̂őÕo[WŋIɍB
	IDirectDraw* pDD1;
	IDirectDrawSurface* pDDS1;
	IDirectDrawSurface* pZ;
	pDD->m_pDirectDraw->QueryInterface(IID_IDirectDraw,(LPVOID*)&pDD1);
	pBack->m_pSurface->QueryInterface(IID_IDirectDrawSurface,(LPVOID*)&pDDS1);

	DDSURFACEDESC ddsd;
	memset( &ddsd, 0,sizeof( ddsd ) );
	ddsd.dwSize = sizeof( ddsd );
	ddsd.dwFlags = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS | DDSD_ZBUFFERBITDEPTH;
	ddsd.dwWidth = pBack->Width();
	ddsd.dwHeight = pBack->Height();
	ddsd.ddsCaps.dwCaps = DDSCAPS_ZBUFFER | dwZBufferMemType;
	ddsd.dwZBufferBitDepth = dwZBufferBitDepth;

	pDD1->CreateSurface(&ddsd, &pZ, NULL);
	if( pDDS1->AddAttachedSurface(pZ) != DD_OK )
		return false;
	pZ->Release();

	// D3DRMfoCX
	if( pIM==NULL )
	{
		hr = m_pDirect3DRM->CreateDeviceFromSurface(NULL,pDD1,pDDS1,0,&m_pDirect3DRMDevice);
	}
	else
	{
		IDirect3D2* p3D2;
		IDirect3DDevice2* pDv2;
		pIM->m_pDirect3D->QueryInterface(IID_IDirect3D2,(LPVOID*)&p3D2);
		pIM->m_pDirect3DDevice->QueryInterface(IID_IDirect3DDevice2,(LPVOID*)&pDv2);

		hr = m_pDirect3DRM->CreateDeviceFromD3D(p3D2,pDv2,&m_pDirect3DRMDevice);
		m_pDirect3DRMDevice->SetBufferCount(2);

		p3D2->Release();
		pDv2->Release();
	}

	pDD1->Release();
	pDDS1->Release();
	if( hr!=D3DRM_OK )
		return false;

	// ftHg掿ݒ
	m_pDirect3DRM->SetDefaultTextureColors(64);
	m_pDirect3DRM->SetDefaultTextureShades(32);
	m_pDirect3DRMDevice->SetShades(32);
	m_pDirect3DRMDevice->SetQuality(D3DRMRENDER_GOURAUD);
	m_pDirect3DRMDevice->SetDither( FALSE );
	m_pDirect3DRMDevice->SetTextureQuality(D3DRMTEXTURE_LINEAR);

	// Createn̊֐ĂԂ̂łŃtOĂ
	m_bInit = true;

	// ftHg̃V[
	m_pScene = new CD3DFrame;
	CreateFrame( m_pScene,NULL );

	// r[|[gƃftHg̃J̐ݒ
	m_pCamera = new CD3DFrame;
	CreateFrame( m_pCamera,m_pScene );
	m_pCamera->SetDirection( m_pScene,CVector(0,0,1),CVector(0,1,0) );
	m_pCamera->SetPosition( m_pScene,CVector(0,0,0) );

	hr = m_pDirect3DRM->CreateViewport(m_pDirect3DRMDevice,m_pCamera->m_pFrame,0,0,
			m_pDirect3DRMDevice->GetWidth(),m_pDirect3DRMDevice->GetHeight(),&m_pDirect3DRMViewport);

	ChangeViewport( NULL , 1000 , 0.01 , 0.01);

	return true;
}

bool CDirect3DRM::CreateFrame( CD3DFrame* pF , CD3DFrame* pParent )
{
	if( !m_bInit )
		return false;

	IDirect3DRMFrame3* pIF;
	HRESULT hr;
	if( pParent==NULL )
		hr = m_pDirect3DRM->CreateFrame( NULL,&pIF );
	else
		hr = m_pDirect3DRM->CreateFrame( pParent->m_pFrame,&pIF );
	if( hr!=D3DRM_OK )
		return false;

	pF->Initialize(&pIF);
	pIF->Release();
	return true;
}

CD3DFrame* CDirect3DRM::SetScene(CD3DFrame * newScene)
{
	CD3DFrame* old = m_pScene;
	m_pScene = newScene;
	return old;
}

CD3DFrame* CDirect3DRM::SetCamera(CD3DFrame * newCamera)
{
	CD3DFrame* old = m_pCamera;
	m_pCamera = newCamera;
	m_pDirect3DRMViewport->SetCamera( m_pCamera->m_pFrame );
	return old;
}

bool CDirect3DRM::CreateMeshBuilder( CD3DMeshBuilder* pM,LPCTSTR xName )
{
	if( !m_bInit )
		return false;

	IDirect3DRMMeshBuilder3* pIM;
	HRESULT hr;
	hr = m_pDirect3DRM->CreateMeshBuilder( &pIM );
	if( hr!=D3DRM_OK )
		return false;
	hr = pIM->Load( (void*)xName,NULL,D3DRMLOAD_FROMFILE,NULL,NULL );
	if( hr!=D3DRM_OK )
		return false;

	pM->Initialize(&pIM);
	pIM->Release();
	return true;
}

void CDirect3DRM::Render()
{
	if( !m_bInit )
		return;

	m_pDirect3DRMViewport->Render(m_pScene->m_pFrame);
}

void CDirect3DRM::ForceClear(RECT * rc)
{
	if( !m_bInit )
		return;

	if( rc!=NULL )
	{
		LPDIRECT3DVIEWPORT vw;
		D3DRECT rect = {rc->left,rc->top,rc->right,rc->bottom};
		m_pDirect3DRMViewport->GetDirect3DViewport(&vw);
		vw->Clear(1,&rect,D3DCLEAR_TARGET);
		vw->Release();
	}
	else
		m_pDirect3DRMViewport->Clear(D3DRMCLEAR_ALL);
}

void CDirect3DRM::NormalClear()
{
	if( !m_bInit )
		return;

	m_pDirect3DRMViewport->Clear(D3DRMCLEAR_DIRTYRECTS);
}

void CDirect3DRM::Tick(double time)
{
	if( !m_bInit )
		return;

	m_pDirect3DRM->Tick( D3DVAL(time) );
}

bool CDirect3DRM::CreateLight( CD3DLight* pL , D3DRMLIGHTTYPE type, COLORREF cl )
{
	IDirect3DRMLight* pIL;

	if( D3DRM_OK!=m_pDirect3DRM->CreateLightRGB(type,D3DVAL( GetRValue(cl)/255.0 ),
											D3DVAL( GetGValue(cl)/255.0 ),
											D3DVAL( GetBValue(cl)/255.0 ),&pIL) )
		return false;

	pL->Initialize(&pIL);
	pIL->Release();
	return true;
}

void CDirect3DRM::ChangeViewport(RECT * rc, double back, double front, double field)
{
	if( !m_bInit )
		return;

	// Rc`悷͈
	if( rc!=NULL )
		m_pDirect3DRMViewport->Configure( rc->left,rc->top,
				(rc->right - rc->left),(rc->bottom - rc->top) );

	// Back,Front ͎͌EiꂼꉓA߁j
	// Field ͋FrontɂƉʂ̏c̔ƓȂ钷
	if( back!=0 )
		m_pDirect3DRMViewport->SetBack(D3DVAL(back));
	if( front!=0 )
		m_pDirect3DRMViewport->SetFront(D3DVAL(front));
	if( field!=0 )
		m_pDirect3DRMViewport->SetField(D3DVAL(field));
}
